import consola from 'consola/src/browser';
export { LogLevel } from 'consola';
const logLevelDebug = 4;
export const defaultLoggerOptions = {
    level: logLevelDebug,
};
export function createLogger(name, options = defaultLoggerOptions) {
    const baseLogger = consola.create(options);
    const logger = baseLogger.withTag(name);
    return Object.assign(Object.assign({}, logger), { deprecated: (symbol, instruction = 'Consult docs for better alternative.', removalVersionTarget) => {
            logger.warn(`Deprecated symbol used '${symbol}'. ${instruction}`, `${removalVersionTarget ? `Will be removed in version ${removalVersionTarget}.` : ''}`);
        } });
}
