import { __awaiter } from "tslib";
import { DI } from '@microsoft/fast-foundation';
import { v4 as uuidv4 } from 'uuid';
import { logger } from '../utils';
class UUIDService {
    /**
     * @UUIDConfig private config: UUIDConfig;
     *
     * // Could inject something like this from the app level:
     * export const AppUUIDConfig = DI.createInterface<UUIDConfig>(); // < Strongly typed key
     * container.register(
     *      Registration.instance(AppUUIDConfig, {
     *          random: [...]
     *      })
     * );
     */
    constructor() { }
    createId(withLogging = false) {
        /**
         * Use this.config to customise uuidv4
         */
        const id = uuidv4();
        withLogging && logger.debug(`UUID.createID ${id}`);
        return id;
    }
    createRemoteId(withLogging = false) {
        return __awaiter(this, void 0, void 0, function* () {
            /**
             * TODO: Revisit async nature of id generation with potential server involvement
             * Use this.config to customise uuidv4
             */
            const id = uuidv4();
            withLogging && logger.debug(`UUID.createRemoteID ${id}`);
            return id;
        });
    }
}
export const UUID = DI.createInterface((x) => x.singleton(UUIDService));
